
!GRPlatformTest methodsFor: 'private' stamp: 'PaoloBonzini 4/7/2010 09:27'!
decodeUtf8Character: aCollectionOfIntegers 
	"Decodes a collection of bytes into a single character. We have this so we can avoid having non-ASCII characters in the source."
	| codec toDecode decoded |
	codec := GRCodec forEncoding: 'utf-8'.
	toDecode := aCollectionOfIntegers asByteArray.
	decoded := codec decode: toDecode.
	self assert: decoded size = 1.
	^ decoded at: 1! !

!GRCodecTest methodsFor: 'accessing' stamp: 'PaoloBonzini 4/7/2010 09:28'!
decodedString
	^'brstrg'! !

!GRCodecTest methodsFor: 'tests' stamp: 'PaoloBonzini 4/7/2010 09:29'!
testCodecLatin1
	#('iso-8859-1' 'ISO-8859-1' ) do:  [ :each | 
		| codec |
		codec := GRCodec forEncoding: each.
		self assert: codec name = each.
		self assert: codec url name = each.
		
		"Dialects may not guarantee anything about the comparability of
		 encoded strings.  Convert to ByteArray for simplicity."
		self assert: (codec encode: self decodedString) asByteArray = self latin1String asByteArray.
		self assert: (codec url encode: self decodedString) asByteArray = self latin1String asByteArray.
		self assert: (codec decode: self latin1String) = self decodedString.
		self assert: (codec url decode: self latin1String) = self decodedString ]! !

!GRUtf8CodecTest methodsFor: 'accessing' stamp: 'PaoloBonzini 4/7/2010 09:30'!
decodedString
	^ 'brstrg'! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'PaoloBonzini 4/7/2010 09:31'!
testCodecUtf8
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec |
		codec := GRCodec forEncoding: codecName.
		self assert: codec name = 'utf-8'.
		self assert: codec url name = 'utf-8'.
		self assert: (codec encode: self decodedString) asByteArray = self utf8String asByteArray.
		self assert: (codec url encode: self decodedString) asByteArray = self utf8String asByteArray.
		self assert: (codec decode: self utf8String) = self decodedString.
		self assert: (codec url decode: self utf8String) = self decodedString ]! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'PaoloBonzini 4/7/2010 09:32'!
testCodecUtf8Bom
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec bom |
		codec := GRCodec forEncoding: codecName.
		bom := self asString: #(239 187 191 ).
		self assert: (codec decode: bom , self utf8String) asByteArray = self decodedString asByteArray.
		self assert: (codec url decode: bom , self utf8String) asByteArray = self decodedString asByteArray]! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'PaoloBonzini 4/7/2010 09:24'!
testCodecUtf8ShortestForm
	"Non shortest form characters should be rejected
	See Corrigendum #1: UTF-8 Shortest Form http://www.unicode.org/versions/corrigendum1.html"
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec abc |
		codec := GRCodec forEncoding: codecName.
		abc := self asString: #(193 129 193 130 193 131 ).
		self
			should: [self deny: (codec decode: abc) = 'ABC' ]
			raise: Error]! !
