
!GRPlatformTest methodsFor: 'private' stamp: 'jf 9/30/2009 00:27'!
decodeUtf8Character: aCollectionOfIntegers 
	"Decodes a collection of bytes into a single character. We have this so we can avoid having non-ASCII characters in the source."
	| codec toDecode decoded |
	codec := GRCodec forEncoding: 'utf-8'.
	toDecode := String streamContents: 
		[ :stream | 
		aCollectionOfIntegers do: [ :each | stream nextPut: (Character codePoint: each) ] ].
	decoded := codec decode: toDecode.
	self assert: decoded size = 1.
	^ decoded at: 1! !

!GRCodecTest methodsFor: 'tests' stamp: 'pmm 2/17/2010 20:04'!
testCodecLatin1
	#('iso-8859-1' 'ISO-8859-1' ) do:  [ :each | 
		| codec |
		codec := GRCodec forEncoding: each.
		self assert: codec name = each.
		self assert: codec url name = each.
		self assert: (codec encode: self latin1String) = self latin1String.
		self assert: (codec url encode: self latin1String) = self latin1String.
		self assert: (codec decode: self latin1String) = self latin1String.
		self assert: (codec url decode: self latin1String) = self latin1String ]! !

!GRUtf8CodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:27'!
latin1String
	^ self asString: #(220 98 232 114 115 116 114 238 241 103 233)! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'pmm 11/15/2009 10:58'!
testCodecUtf8
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec |
		codec := GRCodec forEncoding: codecName.
		self assert: codec name = 'utf-8'.
		self assert: codec url name = 'utf-8'.
		self assert: (codec encode: self latin1String) = self utf8String.
		self assert: (codec url encode: self latin1String) = self utf8String.
		self assert: (codec decode: self utf8String) = self latin1String.
		self assert: (codec url decode: self utf8String) = self latin1String ]! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'pmm 11/15/2009 11:00'!
testCodecUtf8Bom
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec bom |
		codec := GRCodec forEncoding: codecName.
		bom := self asString: #(239 187 191 ).
		self assert: (codec decode: bom , self utf8String) = self latin1String.
		self assert: (codec url decode: bom , self utf8String) = self latin1String ]! !

!GRUtf8CodecTest methodsFor: 'tests' stamp: 'pmm 11/15/2009 11:00'!
testCodecUtf8ShortestForm
	"Non shortest form characters should be rejected
	See Corrigendum #1: UTF-8 Shortest Form http://www.unicode.org/versions/corrigendum1.html"
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec abc |
		codec := GRCodec forEncoding: codecName.
		abc := self asString: #(193 129 193 130 193 131 ).
		self assert: (codec decode: abc) ~= 'ABC' ]! !
